#!usr/bin/env python
"""
"""

import numpy as np
import pybullet as p
import time

from utilities import prGreen
from utilities import prBlue
from utilities import prRed
from utilities import render_environment
from utilities import create_velocity_sliders
from utilities import Robotless


if __name__ == '__main__':

    # define time_step and velocity
    max_vel = 0.5
    time_step = 1.0 / 240.0

    # launch simulation
    render_environment([0.15, 110, -45, [-0., -0.0, -0.]])
    p.setTimeStep(time_step)

    # instantiate robot
    robot = Robotless()
    robot.display_tool_frame()

    # create gui sliders
    sliders = create_velocity_sliders()

    while True:

        velocity = [0.] * 6
        for vel_id in sliders:
            velocity[vel_id - min(sliders)] = p.readUserDebugParameter(vel_id) * max_vel

        # apply movements via set motor control array
        robot.apply_action(velocity, time_step)

        # get velocity ay base and print out
        read_velocity = p.getBaseVelocity(robot.id)
        read_velocity = [*read_velocity[0]] + [*read_velocity[1]]

        # get factor
        factor = np.array(velocity) / np.array(read_velocity)

        print('---')
        prGreen('sent vel: {}'.format(velocity))
        prBlue('read vel:  {}'.format(read_velocity))
        prRed('scale factor: {}'.format(factor))

        p.stepSimulation()
        time.sleep(time_step)







